set ATTRIBUTE;
set N_class := 1..5;
set N_candidate := 1 .. 50;
set CLASS1 := 1 .. 10;
set CLASS2 := 11 .. 20;
set CLASS3 := 21 .. 30;
set CLASS4 := 31 .. 40;
set CLASS5 := 41 .. 50;

param Weight {ATTRIBUTE}  >= 0;
param Posi_status {j in ATTRIBUTE} ;
param Com_status {j in ATTRIBUTE} ;
param QOS {N_candidate,ATTRIBUTE} >= 0;

param MAX {j in ATTRIBUTE} =
	if Com_status[j]==1 then max {i in CLASS1} QOS [i, j] + max {i in CLASS2} QOS [i, j] + max {i in CLASS3} QOS [i, j] + max {i in CLASS4} QOS [i, j] + max {i in CLASS5} QOS [i, j]
		else if Com_status[j]==2 then  (max {i in CLASS1} QOS [i, j]) * (max {i in CLASS2} QOS [i, j]) * (max {i in CLASS3} QOS [i, j])* (max {i in CLASS4} QOS [i, j]) * (max {i in CLASS5} QOS [i, j])
			else if Com_status[j]==3 then  min(max {i in CLASS1} QOS [i, j], max {i in CLASS2} QOS [i, j], max {i in CLASS3} QOS [i, j], max {i in CLASS4} QOS [i, j], max {i in CLASS5} QOS [i, j])
					else (max {i in CLASS1} QOS [i, j] + max {i in CLASS2} QOS [i, j] + max {i in CLASS3} QOS [i, j] + max {i in CLASS4} QOS [i, j] + max {i in CLASS5} QOS [i, j]) /5;

param MIN {j in ATTRIBUTE} =
	if Com_status[j]==1 then min {i in CLASS1} QOS [i, j] + min {i in CLASS2} QOS [i, j] + min {i in CLASS3} QOS [i, j] + min {i in CLASS4} QOS [i, j] + min {i in CLASS5} QOS [i, j]
		else if Com_status[j]==2 then  (min {i in CLASS1} QOS [i, j]) * (min {i in CLASS2} QOS [i, j]) * (min {i in CLASS3} QOS [i, j])* (min {i in CLASS4} QOS [i, j]) * (min {i in CLASS5} QOS [i, j])
			else if Com_status[j]==3 then  min (min {i in CLASS1} QOS [i, j], min {i in CLASS2} QOS [i, j], min {i in CLASS3} QOS [i, j], min {i in CLASS4} QOS [i, j], min {i in CLASS5} QOS [i, j])
					else (min {i in CLASS1} QOS [i, j] + min {i in CLASS2} QOS [i, j] + min {i in CLASS3} QOS [i, j] + min {i in CLASS4} QOS [i, j] + min {i in CLASS5} QOS [i, j]) /5;


var use {i in N_candidate} binary;
var z;

var ComService {k in N_class,j in ATTRIBUTE} =
	if k== 1 then sum {i in CLASS1} use[i]*QOS[i,j]
		else if k== 2 then sum {i in CLASS2} use[i]*QOS[i,j]
			else if k== 3 then sum {i in CLASS3} use[i]*QOS[i,j]
				else if k== 4 then sum {i in CLASS4} use[i]*QOS[i,j]
					else sum {i in CLASS5} use[i]*QOS[i,j];

var ComScore {j in ATTRIBUTE} =
	if Com_status[j]==1 then sum {i in N_class} ComService[i,j]
		else if Com_status[j]==2 then (prod {i in N_class} ComService[i,j])
				else if Com_status[j]==3 then z
					else sum  {i in N_class} ComService[i,j] /5;

var UniComScore {j in ATTRIBUTE} =
	if Posi_status[j] == 1 then (ComScore[j] - MIN[j])/(MAX[j]-MIN[j])
		else  (MAX[j]-ComScore[j] )/(MAX[j]-MIN[j]);

maximize  ComSAW : sum{j in ATTRIBUTE} UniComScore[j]*Weight[j];

subject to def_z {i in N_class, j in ATTRIBUTE: Com_status[j] == 3}: z <= ComService[i,j];
subject to Class1_num: sum {i in CLASS1} use[i]=1;
subject to Class2_num: sum {i in CLASS2} use[i]=1;
subject to Class3_num: sum {i in CLASS3} use[i]=1;
subject to Class4_num: sum {i in CLASS4} use[i]=1;
subject to Class5_num: sum {i in CLASS5} use[i]=1;

